

// This C++ file was created by SanEditor

#include "Atomic/SW_channel/SW_channelSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         SW_channelSAN Constructor             
******************************************************************/


SW_channelSAN::SW_channelSAN(){


  DiagnosisGroup.initialize(2, "DiagnosisGroup");
  DiagnosisGroup.appendGroup((BaseGroupClass*) &Diagnosis_case1);
  DiagnosisGroup.appendGroup((BaseGroupClass*) &Diagnosis_case2);

  Activity* InitialActionList[6]={
    &CCF_propagate, //0
    &OK_failure, //1
    &Safe_fail_OK, //2
    &Diagnosis_case1, //3
    &Diagnosis_case2, //4
    &Repair_unsafe  // 5
  };

  BaseGroupClass* InitialGroupList[5]={
    (BaseGroupClass*) &(OK_failure), 
    (BaseGroupClass*) &(Safe_fail_OK), 
    (BaseGroupClass*) &(DiagnosisGroup), 
    (BaseGroupClass*) &(Repair_unsafe), 
    (BaseGroupClass*) &(CCF_propagate)
  };

  Channel_OK = new Place("Channel_OK" ,1);
  channel_failure = new Place("channel_failure" ,0);
  Safe_state = new Place("Safe_state" ,0);
  Unsafe_state = new Place("Unsafe_state" ,0);
  Unsafe_state_2 = new Place("Unsafe_state_2" ,0);
  Configuration_state = new Place("Configuration_state" ,1);
  System_OK = new Place("System_OK" ,1);
  CCF_active = new Place("CCF_active" ,0);
  BaseStateVariableClass* InitialPlaces[8]={
    Channel_OK,  // 0
    channel_failure,  // 1
    Safe_state,  // 2
    Unsafe_state,  // 3
    Unsafe_state_2,  // 4
    Configuration_state,  // 5
    System_OK,  // 6
    CCF_active   // 7
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("SW_channel", 8, InitialPlaces, 
                        0, InitialROPlaces, 
                        6, InitialActionList, 5, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[16][2]={ 
    {7,0}, {1,0}, {0,1}, {1,1}, {2,2}, {0,2}, {1,3}, {5,3}, {2,3}, 
    {4,3}, {0,3}, {1,4}, {3,4}, {0,5}, {3,5}, {4,5}
  };
  for(int n=0;n<16;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[13][2]={ 
    {7,0}, {6,0}, {0,1}, {6,1}, {2,2}, {6,2}, {1,3}, {6,3}, {1,4}, 
    {6,4}, {6,5}, {3,5}, {4,5}
  };
  for(int n=0;n<13;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<6;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void SW_channelSAN::CustomInitialization() {

}
SW_channelSAN::~SW_channelSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void SW_channelSAN::assignPlacesToActivitiesInst(){
  CCF_propagate.CCF_active = (Place*) LocalStateVariables[7];
  CCF_propagate.System_OK = (Place*) LocalStateVariables[6];
  CCF_propagate.channel_failure = (Place*) LocalStateVariables[1];
}
void SW_channelSAN::assignPlacesToActivitiesTimed(){
  OK_failure.Channel_OK = (Place*) LocalStateVariables[0];
  OK_failure.System_OK = (Place*) LocalStateVariables[6];
  OK_failure.channel_failure = (Place*) LocalStateVariables[1];
  Safe_fail_OK.Safe_state = (Place*) LocalStateVariables[2];
  Safe_fail_OK.System_OK = (Place*) LocalStateVariables[6];
  Safe_fail_OK.Channel_OK = (Place*) LocalStateVariables[0];
  Diagnosis_case1.channel_failure = (Place*) LocalStateVariables[1];
  Diagnosis_case1.System_OK = (Place*) LocalStateVariables[6];
  Diagnosis_case1.Configuration_state = (Place*) LocalStateVariables[5];
  Diagnosis_case1.Safe_state = (Place*) LocalStateVariables[2];
  Diagnosis_case1.Unsafe_state_2 = (Place*) LocalStateVariables[4];
  Diagnosis_case1.Channel_OK = (Place*) LocalStateVariables[0];
  Diagnosis_case2.channel_failure = (Place*) LocalStateVariables[1];
  Diagnosis_case2.System_OK = (Place*) LocalStateVariables[6];
  Diagnosis_case2.Unsafe_state = (Place*) LocalStateVariables[3];
  Repair_unsafe.System_OK = (Place*) LocalStateVariables[6];
  Repair_unsafe.Unsafe_state = (Place*) LocalStateVariables[3];
  Repair_unsafe.Unsafe_state_2 = (Place*) LocalStateVariables[4];
  Repair_unsafe.Channel_OK = (Place*) LocalStateVariables[0];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================CCF_propagateActivity========================*/


SW_channelSAN::CCF_propagateActivity::CCF_propagateActivity(){
  ActivityInitialize("CCF_propagate",4,Instantaneous , RaceEnabled, 2,2, false);
}

void SW_channelSAN::CCF_propagateActivity::LinkVariables(){
  CCF_active->Register(&CCF_active_Mobius_Mark);
  System_OK->Register(&System_OK_Mobius_Mark);
  channel_failure->Register(&channel_failure_Mobius_Mark);
}

bool SW_channelSAN::CCF_propagateActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(CCF_active_Mobius_Mark)) >=1)&&((System_OK->Mark() > 0)));
  return NewEnabled;
}

double SW_channelSAN::CCF_propagateActivity::Weight(){ 
  return 1;
}

bool SW_channelSAN::CCF_propagateActivity::ReactivationPredicate(){ 
  return false;
}

bool SW_channelSAN::CCF_propagateActivity::ReactivationFunction(){ 
  return false;
}

double SW_channelSAN::CCF_propagateActivity::SampleDistribution(){
  return 0;
}

double* SW_channelSAN::CCF_propagateActivity::ReturnDistributionParameters(){
    return NULL;
}

int SW_channelSAN::CCF_propagateActivity::Rank(){
  return 1;
}

BaseActionClass* SW_channelSAN::CCF_propagateActivity::Fire(){
  ;
  (*(CCF_active_Mobius_Mark))--;
  (*(channel_failure_Mobius_Mark))++;
  return this;
}

/*======================OK_failureActivity========================*/

SW_channelSAN::OK_failureActivity::OK_failureActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("OK_failure",0,Exponential, RaceEnabled, 2,2, false);
}

SW_channelSAN::OK_failureActivity::~OK_failureActivity(){
  delete[] TheDistributionParameters;
}

void SW_channelSAN::OK_failureActivity::LinkVariables(){
  Channel_OK->Register(&Channel_OK_Mobius_Mark);
  System_OK->Register(&System_OK_Mobius_Mark);
  channel_failure->Register(&channel_failure_Mobius_Mark);
}

bool SW_channelSAN::OK_failureActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Channel_OK_Mobius_Mark)) >=1)&&((System_OK->Mark() > 0)));
  return NewEnabled;
}

double SW_channelSAN::OK_failureActivity::Rate(){
  return channel_failure_rate;
  return 1.0;  // default rate if none is specified
}

double SW_channelSAN::OK_failureActivity::Weight(){ 
  return 1;
}

bool SW_channelSAN::OK_failureActivity::ReactivationPredicate(){ 
  return false;
}

bool SW_channelSAN::OK_failureActivity::ReactivationFunction(){ 
  return false;
}

double SW_channelSAN::OK_failureActivity::SampleDistribution(){
  return TheDistribution->Exponential(channel_failure_rate);
}

double* SW_channelSAN::OK_failureActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int SW_channelSAN::OK_failureActivity::Rank(){
  return 1;
}

BaseActionClass* SW_channelSAN::OK_failureActivity::Fire(){
  ;
  (*(Channel_OK_Mobius_Mark))--;
  (*(channel_failure_Mobius_Mark))++;
  return this;
}

/*======================Safe_fail_OKActivity========================*/

SW_channelSAN::Safe_fail_OKActivity::Safe_fail_OKActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Safe_fail_OK",1,Exponential, RaceEnabled, 2,2, false);
}

SW_channelSAN::Safe_fail_OKActivity::~Safe_fail_OKActivity(){
  delete[] TheDistributionParameters;
}

void SW_channelSAN::Safe_fail_OKActivity::LinkVariables(){
  Safe_state->Register(&Safe_state_Mobius_Mark);
  System_OK->Register(&System_OK_Mobius_Mark);
  Channel_OK->Register(&Channel_OK_Mobius_Mark);
}

bool SW_channelSAN::Safe_fail_OKActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Safe_state_Mobius_Mark)) >=1)&&((System_OK->Mark() > 0)));
  return NewEnabled;
}

double SW_channelSAN::Safe_fail_OKActivity::Rate(){
  return SS_repair_rate;
  return 1.0;  // default rate if none is specified
}

double SW_channelSAN::Safe_fail_OKActivity::Weight(){ 
  return 1;
}

bool SW_channelSAN::Safe_fail_OKActivity::ReactivationPredicate(){ 
  return false;
}

bool SW_channelSAN::Safe_fail_OKActivity::ReactivationFunction(){ 
  return false;
}

double SW_channelSAN::Safe_fail_OKActivity::SampleDistribution(){
  return TheDistribution->Exponential(SS_repair_rate);
}

double* SW_channelSAN::Safe_fail_OKActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int SW_channelSAN::Safe_fail_OKActivity::Rank(){
  return 1;
}

BaseActionClass* SW_channelSAN::Safe_fail_OKActivity::Fire(){
  ;
  (*(Safe_state_Mobius_Mark))--;
  (*(Channel_OK_Mobius_Mark))++;
  return this;
}

/*======================DiagnosisActivity_case1========================*/

SW_channelSAN::DiagnosisActivity_case1::DiagnosisActivity_case1(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Diagnosis_case1",2,Deterministic, RaceEnabled, 5,2, false);
}

SW_channelSAN::DiagnosisActivity_case1::~DiagnosisActivity_case1(){
  delete[] TheDistributionParameters;
}

void SW_channelSAN::DiagnosisActivity_case1::LinkVariables(){
  channel_failure->Register(&channel_failure_Mobius_Mark);
  System_OK->Register(&System_OK_Mobius_Mark);
  Configuration_state->Register(&Configuration_state_Mobius_Mark);
  Safe_state->Register(&Safe_state_Mobius_Mark);
  Unsafe_state_2->Register(&Unsafe_state_2_Mobius_Mark);
  Channel_OK->Register(&Channel_OK_Mobius_Mark);
}

bool SW_channelSAN::DiagnosisActivity_case1::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(channel_failure_Mobius_Mark)) >=1)&&((System_OK->Mark() > 0)));
  return NewEnabled;
}

double SW_channelSAN::DiagnosisActivity_case1::DeterministicParamValue(){
  return 0.0000277778;
  return 1.0;  // default rate if none is specified
}

double SW_channelSAN::DiagnosisActivity_case1::Weight(){ 
  return(failure_coverage);
}

bool SW_channelSAN::DiagnosisActivity_case1::ReactivationPredicate(){ 
  return false;
}

bool SW_channelSAN::DiagnosisActivity_case1::ReactivationFunction(){ 
  return false;
}

double SW_channelSAN::DiagnosisActivity_case1::SampleDistribution(){
  return 0.0000277778;
}

double* SW_channelSAN::DiagnosisActivity_case1::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int SW_channelSAN::DiagnosisActivity_case1::Rank(){
  return 1;
}

BaseActionClass* SW_channelSAN::DiagnosisActivity_case1::Fire(){
  ;
  (*(channel_failure_Mobius_Mark))--;
  if(Configuration_state->Mark() > 0)
  {
    Safe_state->Mark() = 1;
    Unsafe_state_2->Mark() = 0;
  }
else
  {
    Unsafe_state_2->Mark() = 1;
    Safe_state->Mark() = 0;
  }
// Now set Channel_OK to 0
Channel_OK->Mark() = 0;
  return this;
}

/*======================DiagnosisActivity_case2========================*/

SW_channelSAN::DiagnosisActivity_case2::DiagnosisActivity_case2(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Diagnosis_case2",2,Deterministic, RaceEnabled, 2,2, false);
}

SW_channelSAN::DiagnosisActivity_case2::~DiagnosisActivity_case2(){
  delete[] TheDistributionParameters;
}

void SW_channelSAN::DiagnosisActivity_case2::LinkVariables(){
  channel_failure->Register(&channel_failure_Mobius_Mark);
  System_OK->Register(&System_OK_Mobius_Mark);
  Unsafe_state->Register(&Unsafe_state_Mobius_Mark);
}

bool SW_channelSAN::DiagnosisActivity_case2::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(channel_failure_Mobius_Mark)) >=1)&&((System_OK->Mark() > 0)));
  return NewEnabled;
}

double SW_channelSAN::DiagnosisActivity_case2::DeterministicParamValue(){
  return 0.0000277778;
  return 1.0;  // default rate if none is specified
}

double SW_channelSAN::DiagnosisActivity_case2::Weight(){ 
  return((double)(1.0) - failure_coverage);
}

bool SW_channelSAN::DiagnosisActivity_case2::ReactivationPredicate(){ 
  return false;
}

bool SW_channelSAN::DiagnosisActivity_case2::ReactivationFunction(){ 
  return false;
}

double SW_channelSAN::DiagnosisActivity_case2::SampleDistribution(){
  return 0.0000277778;
}

double* SW_channelSAN::DiagnosisActivity_case2::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int SW_channelSAN::DiagnosisActivity_case2::Rank(){
  return 1;
}

BaseActionClass* SW_channelSAN::DiagnosisActivity_case2::Fire(){
  ;
  (*(channel_failure_Mobius_Mark))--;
  (*(Unsafe_state_Mobius_Mark))++;
  return this;
}

/*======================Repair_unsafeActivity========================*/

SW_channelSAN::Repair_unsafeActivity::Repair_unsafeActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Repair_unsafe",3,Exponential, RaceEnabled, 3,3, false);
}

SW_channelSAN::Repair_unsafeActivity::~Repair_unsafeActivity(){
  delete[] TheDistributionParameters;
}

void SW_channelSAN::Repair_unsafeActivity::LinkVariables(){
  System_OK->Register(&System_OK_Mobius_Mark);
  Unsafe_state->Register(&Unsafe_state_Mobius_Mark);
  Unsafe_state_2->Register(&Unsafe_state_2_Mobius_Mark);
  Channel_OK->Register(&Channel_OK_Mobius_Mark);
}

bool SW_channelSAN::Repair_unsafeActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((System_OK->Mark() > 0))&&(((Unsafe_state->Mark() > 0) || (Unsafe_state_2->Mark() > 0))));
  return NewEnabled;
}

double SW_channelSAN::Repair_unsafeActivity::Rate(){
  return USF_repair_rate;
  return 1.0;  // default rate if none is specified
}

double SW_channelSAN::Repair_unsafeActivity::Weight(){ 
  return 1;
}

bool SW_channelSAN::Repair_unsafeActivity::ReactivationPredicate(){ 
  return false;
}

bool SW_channelSAN::Repair_unsafeActivity::ReactivationFunction(){ 
  return false;
}

double SW_channelSAN::Repair_unsafeActivity::SampleDistribution(){
  return TheDistribution->Exponential(USF_repair_rate);
}

double* SW_channelSAN::Repair_unsafeActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int SW_channelSAN::Repair_unsafeActivity::Rank(){
  return 1;
}

BaseActionClass* SW_channelSAN::Repair_unsafeActivity::Fire(){
  ;
  // Repar results in resets unsafe fail states. 
Unsafe_state->Mark() = 0;
Unsafe_state_2->Mark() = 0;
  (*(Channel_OK_Mobius_Mark))++;
  return this;
}

