

// This C++ file was created by SanEditor

#include "Atomic/T_Conf_channel/T_Conf_channelSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         T_Conf_channelSAN Constructor             
******************************************************************/


T_Conf_channelSAN::T_Conf_channelSAN(){


  Activity* InitialActionList[4]={
    &torque_loop_step, //0
    &Torque_request, //1
    &Detection_window, //2
    &T_inc_step  // 3
  };

  BaseGroupClass* InitialGroupList[4]={
    (BaseGroupClass*) &(Torque_request), 
    (BaseGroupClass*) &(Detection_window), 
    (BaseGroupClass*) &(T_inc_step), 
    (BaseGroupClass*) &(torque_loop_step)
  };

  Attack_in_progress = new Place("Attack_in_progress" ,0);
  T_increment = new Place("T_increment" ,0);
  Torque_state = new Place("Torque_state" ,1);
  Detected = new Place("Detected" ,0);
  System_unsafe = new Place("System_unsafe" ,0);
  System_safe = new Place("System_safe" ,0);
  System_OK = new Place("System_OK" ,1);
  Attack_Active = new Place("Attack_Active" ,0);
  Missed_unsafe = new Place("Missed_unsafe" ,0);
  Missed_OK = new Place("Missed_OK" ,0);
  CH1_SS_OK = new Place("CH1_SS_OK" ,1);
  CH2_SS_OK = new Place("CH2_SS_OK" ,1);
  FalseAlarmFlag = new Place("FalseAlarmFlag" ,0);
  double temp_Detection_probdouble = 0;
  Detection_prob = new ExtendedPlace<double>("Detection_prob",temp_Detection_probdouble);
  double temp_Last_Valid_Torque_timestampdouble = 0;
  Last_Valid_Torque_timestamp = new ExtendedPlace<double>("Last_Valid_Torque_timestamp",temp_Last_Valid_Torque_timestampdouble);
  double temp_T_value_stepdouble = 0;
  T_value_step = new ExtendedPlace<double>("T_value_step",temp_T_value_stepdouble);
  double temp_T_cur_valuedouble = 0;
  T_cur_value = new ExtendedPlace<double>("T_cur_value",temp_T_cur_valuedouble);
  double temp_step_ratedouble = 0;
  step_rate = new ExtendedPlace<double>("step_rate",temp_step_ratedouble);
  double temp_T_a_cur_valuedouble = 0;
  T_a_cur_value = new ExtendedPlace<double>("T_a_cur_value",temp_T_a_cur_valuedouble);
  short temp_Debuggingshort = 0;
  Debugging = new ExtendedPlace<short>("Debugging",temp_Debuggingshort);
  BaseStateVariableClass* InitialPlaces[20]={
    Attack_in_progress,  // 0
    T_increment,  // 1
    Torque_state,  // 2
    Detected,  // 3
    System_unsafe,  // 4
    System_safe,  // 5
    System_OK,  // 6
    Attack_Active,  // 7
    Missed_unsafe,  // 8
    Missed_OK,  // 9
    CH1_SS_OK,  // 10
    CH2_SS_OK,  // 11
    FalseAlarmFlag,  // 12
    Detection_prob,  // 13
    Last_Valid_Torque_timestamp,  // 14
    T_value_step,  // 15
    T_cur_value,  // 16
    step_rate,  // 17
    T_a_cur_value,  // 18
    Debugging   // 19
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("T_Conf_channel", 20, InitialPlaces, 
                        0, InitialROPlaces, 
                        4, InitialActionList, 4, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[42][2]={ 
    {0,0}, {1,0}, {13,0}, {15,0}, {17,0}, {18,0}, {16,0}, {14,0}, 
    {2,1}, {16,1}, {14,1}, {12,1}, {10,1}, {11,1}, {6,1}, {5,1}, 
    {4,1}, {1,1}, {7,1}, {3,1}, {9,1}, {8,1}, {7,2}, {3,2}, {10,2}, 
    {11,2}, {6,2}, {5,2}, {4,2}, {1,2}, {8,2}, {9,2}, {1,3}, 
    {7,3}, {16,3}, {18,3}, {15,3}, {14,3}, {19,3}, {3,3}, {8,3}, 
    {9,3}
  };
  for(int n=0;n<42;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[8][2]={ 
    {0,0}, {1,0}, {6,0}, {2,1}, {1,1}, {7,2}, {6,2}, {1,3}
  };
  for(int n=0;n<8;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<4;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void T_Conf_channelSAN::CustomInitialization() {

}
T_Conf_channelSAN::~T_Conf_channelSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void T_Conf_channelSAN::assignPlacesToActivitiesInst(){
  torque_loop_step.Attack_in_progress = (Place*) LocalStateVariables[0];
  torque_loop_step.T_increment = (Place*) LocalStateVariables[1];
  torque_loop_step.System_OK = (Place*) LocalStateVariables[6];
  torque_loop_step.Detection_prob = (ExtendedPlace<double>*) LocalStateVariables[13];
  torque_loop_step.T_value_step = (ExtendedPlace<double>*) LocalStateVariables[15];
  torque_loop_step.step_rate = (ExtendedPlace<double>*) LocalStateVariables[17];
  torque_loop_step.T_a_cur_value = (ExtendedPlace<double>*) LocalStateVariables[18];
  torque_loop_step.T_cur_value = (ExtendedPlace<double>*) LocalStateVariables[16];
  torque_loop_step.Last_Valid_Torque_timestamp = (ExtendedPlace<double>*) LocalStateVariables[14];
}
void T_Conf_channelSAN::assignPlacesToActivitiesTimed(){
  Torque_request.Torque_state = (Place*) LocalStateVariables[2];
  Torque_request.T_increment = (Place*) LocalStateVariables[1];
  Torque_request.T_cur_value = (ExtendedPlace<double>*) LocalStateVariables[16];
  Torque_request.Last_Valid_Torque_timestamp = (ExtendedPlace<double>*) LocalStateVariables[14];
  Torque_request.FalseAlarmFlag = (Place*) LocalStateVariables[12];
  Torque_request.CH1_SS_OK = (Place*) LocalStateVariables[10];
  Torque_request.CH2_SS_OK = (Place*) LocalStateVariables[11];
  Torque_request.System_OK = (Place*) LocalStateVariables[6];
  Torque_request.System_safe = (Place*) LocalStateVariables[5];
  Torque_request.System_unsafe = (Place*) LocalStateVariables[4];
  Torque_request.Attack_Active = (Place*) LocalStateVariables[7];
  Torque_request.Detected = (Place*) LocalStateVariables[3];
  Torque_request.Missed_OK = (Place*) LocalStateVariables[9];
  Torque_request.Missed_unsafe = (Place*) LocalStateVariables[8];
  Detection_window.Attack_Active = (Place*) LocalStateVariables[7];
  Detection_window.System_OK = (Place*) LocalStateVariables[6];
  Detection_window.Detected = (Place*) LocalStateVariables[3];
  Detection_window.CH1_SS_OK = (Place*) LocalStateVariables[10];
  Detection_window.CH2_SS_OK = (Place*) LocalStateVariables[11];
  Detection_window.System_safe = (Place*) LocalStateVariables[5];
  Detection_window.System_unsafe = (Place*) LocalStateVariables[4];
  Detection_window.T_increment = (Place*) LocalStateVariables[1];
  Detection_window.Missed_unsafe = (Place*) LocalStateVariables[8];
  Detection_window.Missed_OK = (Place*) LocalStateVariables[9];
  T_inc_step.T_increment = (Place*) LocalStateVariables[1];
  T_inc_step.Attack_Active = (Place*) LocalStateVariables[7];
  T_inc_step.T_cur_value = (ExtendedPlace<double>*) LocalStateVariables[16];
  T_inc_step.T_a_cur_value = (ExtendedPlace<double>*) LocalStateVariables[18];
  T_inc_step.T_value_step = (ExtendedPlace<double>*) LocalStateVariables[15];
  T_inc_step.Last_Valid_Torque_timestamp = (ExtendedPlace<double>*) LocalStateVariables[14];
  T_inc_step.Debugging = (ExtendedPlace<short>*) LocalStateVariables[19];
  T_inc_step.Detected = (Place*) LocalStateVariables[3];
  T_inc_step.Missed_unsafe = (Place*) LocalStateVariables[8];
  T_inc_step.Missed_OK = (Place*) LocalStateVariables[9];
  T_inc_step.step_rate = (ExtendedPlace<double>*) LocalStateVariables[17];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================torque_loop_stepActivity========================*/


T_Conf_channelSAN::torque_loop_stepActivity::torque_loop_stepActivity(){
  ActivityInitialize("torque_loop_step",3,Instantaneous , RaceEnabled, 8,3, false);
}

void T_Conf_channelSAN::torque_loop_stepActivity::LinkVariables(){
  Attack_in_progress->Register(&Attack_in_progress_Mobius_Mark);
  T_increment->Register(&T_increment_Mobius_Mark);
  System_OK->Register(&System_OK_Mobius_Mark);






}

bool T_Conf_channelSAN::torque_loop_stepActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Attack_in_progress_Mobius_Mark)) >=1)&&((T_increment->Mark() == 0))&&((System_OK->Mark() > 0)));
  return NewEnabled;
}

double T_Conf_channelSAN::torque_loop_stepActivity::Weight(){ 
  return 1;
}

bool T_Conf_channelSAN::torque_loop_stepActivity::ReactivationPredicate(){ 
  return false;
}

bool T_Conf_channelSAN::torque_loop_stepActivity::ReactivationFunction(){ 
  return false;
}

double T_Conf_channelSAN::torque_loop_stepActivity::SampleDistribution(){
  return 0;
}

double* T_Conf_channelSAN::torque_loop_stepActivity::ReturnDistributionParameters(){
    return NULL;
}

int T_Conf_channelSAN::torque_loop_stepActivity::Rank(){
  return 1;
}

BaseActionClass* T_Conf_channelSAN::torque_loop_stepActivity::Fire(){
  ;
  ;
  (*(Attack_in_progress_Mobius_Mark))--;
  static UserDistributions dist(0, 31415);
// Set the value of the offset.
double offset = dist.Normal(T_V_Offset_mean,T_V_Offset_stddev);
double value = (double)(T_V_steps_min);
if(T_V_steps_min != T_V_steps_max)
  value = dist.Uniform((double)(T_V_steps_min),(double)(T_V_steps_max));
// assigns a random number of tokens to Torque_increment, i.e.how many steps will be used to set the new torque. 
T_increment->Mark() = (int)(value);
// Detection probability is defined as a global variable D_T_attack_prob (double).
Detection_prob->Mark() = D_T_attack_prob;
// Set the T_value_step
T_value_step->Mark() = offset / T_increment->Mark();
// The torque value remains unchanged
step_rate->Mark() = T_V_step_interval_mean;	// This guarantees that unless normal 
						// torque request occurs during the attack
						// the attack will not get detected for
						// violation of the timing constraints.
// Now take the timestamp of the start of the window
T_a_cur_value->Mark() = T_cur_value->Mark();	// Takes a snapshot of the current values.
Last_Valid_Torque_timestamp->Mark() = BaseModelClass::LastActionTime;
  return this;
}

/*======================Torque_requestActivity========================*/

T_Conf_channelSAN::Torque_requestActivity::Torque_requestActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Torque_request",0,Exponential, RaceEnabled, 14,2, false);
}

T_Conf_channelSAN::Torque_requestActivity::~Torque_requestActivity(){
  delete[] TheDistributionParameters;
}

void T_Conf_channelSAN::Torque_requestActivity::LinkVariables(){
  Torque_state->Register(&Torque_state_Mobius_Mark);
  T_increment->Register(&T_increment_Mobius_Mark);


  FalseAlarmFlag->Register(&FalseAlarmFlag_Mobius_Mark);
  CH1_SS_OK->Register(&CH1_SS_OK_Mobius_Mark);
  CH2_SS_OK->Register(&CH2_SS_OK_Mobius_Mark);
  System_OK->Register(&System_OK_Mobius_Mark);
  System_safe->Register(&System_safe_Mobius_Mark);
  System_unsafe->Register(&System_unsafe_Mobius_Mark);
  Attack_Active->Register(&Attack_Active_Mobius_Mark);
  Detected->Register(&Detected_Mobius_Mark);
  Missed_OK->Register(&Missed_OK_Mobius_Mark);
  Missed_unsafe->Register(&Missed_unsafe_Mobius_Mark);
}

bool T_Conf_channelSAN::Torque_requestActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Torque_state_Mobius_Mark)) >=1)&&((T_increment->Mark() > 0)));
  return NewEnabled;
}

double T_Conf_channelSAN::Torque_requestActivity::Rate(){
  return torque_req_rate;
  return 1.0;  // default rate if none is specified
}

double T_Conf_channelSAN::Torque_requestActivity::Weight(){ 
  return 1;
}

bool T_Conf_channelSAN::Torque_requestActivity::ReactivationPredicate(){ 
  return false;
}

bool T_Conf_channelSAN::Torque_requestActivity::ReactivationFunction(){ 
  return false;
}

double T_Conf_channelSAN::Torque_requestActivity::SampleDistribution(){
  return TheDistribution->Exponential(torque_req_rate);
}

double* T_Conf_channelSAN::Torque_requestActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int T_Conf_channelSAN::Torque_requestActivity::Rank(){
  return 1;
}

BaseActionClass* T_Conf_channelSAN::Torque_requestActivity::Fire(){
  ;
  (*(Torque_state_Mobius_Mark))--;
  // Here could set T_cur_value to a non-zero value, but not done yet. 
// In other words, the model assumes implicitly that T_cur_value will 
// be 0 at the time a torque attack is launched.

double old_value = T_cur_value->Mark();		// Will be set to 0 by a normal torque attack.
T_cur_value->Mark() = (double)(0.0); // Overrides whatever it might have become.
double old_stamp = Last_Valid_Torque_timestamp->Mark();
Last_Valid_Torque_timestamp->Mark() = BaseModelClass::LastActionTime;	
double offset = old_value;	// The new torque value would be 0, 
				// hence the absolute value of the difference is the old value.
double stamp_offset = Last_Valid_Torque_timestamp->Mark() - old_stamp;
if((offset > v_delta) || (stamp_offset < t_delta))
  {
    // Here the difference between the 'correct' value/stamp and 
    // the 'current' value/stamp exceeds the thresholds 
    // This amounts to a faulse alarm
    FalseAlarmFlag->Mark() = 1;	// Set the flag to false alarm.
    // For the time being "fail stop" is implemented
    if((CH1_SS_OK->Mark() > 0) || (CH2_SS_OK->Mark() > 0))
      {
    	System_OK->Mark() = 0;
    	System_safe->Mark() = 1;
    	System_unsafe->Mark() = 0;
      }
    else
      {
    	System_OK->Mark() = 0;
    	System_safe->Mark() = 0;
    	System_unsafe->Mark() = 1;
      }
    // Since the system is set to failure, any further processing should be blocked.
    T_increment->Mark() = 0;
    Attack_Active->Mark() = 0;
  }
Detected->Mark() = 0;
Missed_OK->Mark() = 0;
Missed_unsafe->Mark() = 0;
// FalseAlarmFlag->Mark() = 2;

  (*(Torque_state_Mobius_Mark))++;
  return this;
}

/*======================Detection_windowActivity========================*/

T_Conf_channelSAN::Detection_windowActivity::Detection_windowActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Detection_window",1,Deterministic, RaceEnabled, 10,2, false);
}

T_Conf_channelSAN::Detection_windowActivity::~Detection_windowActivity(){
  delete[] TheDistributionParameters;
}

void T_Conf_channelSAN::Detection_windowActivity::LinkVariables(){
  Attack_Active->Register(&Attack_Active_Mobius_Mark);
  System_OK->Register(&System_OK_Mobius_Mark);
  Detected->Register(&Detected_Mobius_Mark);
  CH1_SS_OK->Register(&CH1_SS_OK_Mobius_Mark);
  CH2_SS_OK->Register(&CH2_SS_OK_Mobius_Mark);
  System_safe->Register(&System_safe_Mobius_Mark);
  System_unsafe->Register(&System_unsafe_Mobius_Mark);
  T_increment->Register(&T_increment_Mobius_Mark);
  Missed_unsafe->Register(&Missed_unsafe_Mobius_Mark);
  Missed_OK->Register(&Missed_OK_Mobius_Mark);
}

bool T_Conf_channelSAN::Detection_windowActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Attack_Active_Mobius_Mark)) >=1)&&((System_OK->Mark() > 0)));
  return NewEnabled;
}

double T_Conf_channelSAN::Detection_windowActivity::DeterministicParamValue(){
  return t_window;
  return 1.0;  // default rate if none is specified
}

double T_Conf_channelSAN::Detection_windowActivity::Weight(){ 
  return 1;
}

bool T_Conf_channelSAN::Detection_windowActivity::ReactivationPredicate(){ 
  return false;
}

bool T_Conf_channelSAN::Detection_windowActivity::ReactivationFunction(){ 
  return false;
}

double T_Conf_channelSAN::Detection_windowActivity::SampleDistribution(){
  return t_window;
}

double* T_Conf_channelSAN::Detection_windowActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int T_Conf_channelSAN::Detection_windowActivity::Rank(){
  return 1;
}

BaseActionClass* T_Conf_channelSAN::Detection_windowActivity::Fire(){
  ;
  (*(Attack_Active_Mobius_Mark))--;
  if(Detected->Mark() > 0)
  {
    // If detected there are two options 
    // 1. Do nothing, the detected forged request is ignored. 
    // 2. The eMotor tries to go to safe state. 
    // For the time being "Do nothing is adopted"

	    if((CH1_SS_OK->Mark() > 0) || (CH2_SS_OK->Mark() > 0))
	      {
	    	System_OK->Mark() = 0;
	    	System_safe->Mark() = 1;
	    	System_unsafe->Mark() = 0;
	      }
	    else
	      {
	    	System_OK->Mark() = 0;
	    	System_safe->Mark() = 0;
	    	System_unsafe->Mark() = 1;
	      }

    // Since the system is set to failure, any further processing should be blocked.
    T_increment->Mark() = 0;
    Attack_Active->Mark() = 0;
  }
else
  {
    if(Missed_unsafe->Mark() > 0)	// If only OK misses - do nothing. 
      {
      	 // Here the attack has not been detected at all and at least one of the misses is unsafe. 
      	 // The system will be moving to a unsafe state.
      	 System_OK->Mark() = 0;
      	 System_safe->Mark() = 0;
      	 System_unsafe->Mark() = 1;
         // Since the system is set to failure, any further processing should be blocked.
    	 T_increment->Mark() = 0;
    	 Attack_Active->Mark() = 0;
      }
  }
// Now reset the flags.
Detected->Mark() = 0;
Missed_OK->Mark() = 0;
Missed_unsafe->Mark() = 0;
  return this;
}

/*======================T_inc_stepActivity========================*/

T_Conf_channelSAN::T_inc_stepActivity::T_inc_stepActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("T_inc_step",2,Exponential, RaceEnabled, 10,1, false);
}

T_Conf_channelSAN::T_inc_stepActivity::~T_inc_stepActivity(){
  delete[] TheDistributionParameters;
}

void T_Conf_channelSAN::T_inc_stepActivity::LinkVariables(){
  T_increment->Register(&T_increment_Mobius_Mark);
  Attack_Active->Register(&Attack_Active_Mobius_Mark);





  Detected->Register(&Detected_Mobius_Mark);
  Missed_unsafe->Register(&Missed_unsafe_Mobius_Mark);
  Missed_OK->Register(&Missed_OK_Mobius_Mark);

}

bool T_Conf_channelSAN::T_inc_stepActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(T_increment_Mobius_Mark)) >=1));
  return NewEnabled;
}

double T_Conf_channelSAN::T_inc_stepActivity::Rate(){
  return step_rate->Mark();
  return 1.0;  // default rate if none is specified
}

double T_Conf_channelSAN::T_inc_stepActivity::Weight(){ 
  return 1;
}

bool T_Conf_channelSAN::T_inc_stepActivity::ReactivationPredicate(){ 
  return false;
}

bool T_Conf_channelSAN::T_inc_stepActivity::ReactivationFunction(){ 
  return false;
}

double T_Conf_channelSAN::T_inc_stepActivity::SampleDistribution(){
  return TheDistribution->Exponential(step_rate->Mark());
}

double* T_Conf_channelSAN::T_inc_stepActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int T_Conf_channelSAN::T_inc_stepActivity::Rank(){
  return 1;
}

BaseActionClass* T_Conf_channelSAN::T_inc_stepActivity::Fire(){
  (*(T_increment_Mobius_Mark))--;
  static UserDistributions dist_output(0, 31415);
double detect_output = dist_output.Uniform((double)(0.0),(double)(1.0));	// used to model non-deterministic 
										// detection other than violation of thresholds
double old_value = T_cur_value->Mark();		// Will be set to 0 by a normal torque attack.
T_a_cur_value->Mark() += T_value_step->Mark();
double old_stamp = Last_Valid_Torque_timestamp->Mark();
Last_Valid_Torque_timestamp->Mark() = BaseModelClass::LastActionTime;	// May be altered by normal torque requests.
double offset = T_a_cur_value->Mark() - old_value;
double stamp_offset = Last_Valid_Torque_timestamp->Mark() - old_stamp;
Debugging->Mark() = 0; 
if(offset > v_delta)
  Debugging->Mark() += 1;
if(stamp_offset < t_delta)
  Debugging->Mark() += 2;
if(detect_output > D_T_attack_prob)
  Debugging->Mark() += 4;
// if((offset > v_delta) || (stamp_offset < t_delta) || (detect_output > D_T_attack_prob))
if((offset > v_delta) || (stamp_offset < t_delta))
  {
    // Here the difference between the 'correct' value/stamp and 
    // the 'current' value/stamp exceeds the thresholds 
    // or detection on the output (D_T_attack_prob).
    // Detection of a violation of the thresholds.
    Detected->Mark()++;
  }
else
  {
    // Here is the attack has not been detected. 
    // Now check if T_a_cur_value->Mark()deviation is grater than v_delta
    if(T_a_cur_value->Mark() > v_delta)		// Must check the accumulated offset, kept in T_a_cur_value
      Missed_unsafe->Mark()++;
    else
      Missed_OK->Mark()++;
  }
T_cur_value->Mark() = T_a_cur_value->Mark();
  (*(Attack_Active_Mobius_Mark))++;
  return this;
}

