#include "Composed/Div_SW/Div_SWRJ.h"
char * Div_SWRJ__SharedNames[] = {"Attack_conf_1", "Attack_conf_2", "AttackedID_1", "AttackedID_2", "CCF_active", "CH1_OK", "CH1_SS_OK", "CH1_Safe_State", "CH2_OK", "CH2_SS_OK", "CH2_Safe_State", "C_CH_1_attacked", "C_CH_2_attacked", "System_OK", "System_Safe_Failure", "System_Unsafe_State", "Torque_Attack_in_progress"};

Div_SWRJ::Div_SWRJ():Join("Div_Software", 5, 17,Div_SWRJ__SharedNames) {
  Channel_1 = new Div_SWRJ__Channel_1();
  ModelArray[0] = (BaseModelClass*) Channel_1;
  ModelArray[0]->DefineName("Channel_1");
  Channel_2 = new Div_SWRJ__Channel_2();
  ModelArray[1] = (BaseModelClass*) Channel_2;
  ModelArray[1]->DefineName("Channel_2");
  Adversary = new AdversarySAN();
  ModelArray[2] = (BaseModelClass*) Adversary;
  ModelArray[2]->DefineName("Adversary");
  Adjudicator = new AdjudicatorSAN();
  ModelArray[3] = (BaseModelClass*) Adjudicator;
  ModelArray[3]->DefineName("Adjudicator");
  T_Conf_channel = new T_Conf_channelSAN();
  ModelArray[4] = (BaseModelClass*) T_Conf_channel;
  ModelArray[4]->DefineName("T_Conf_channel");

  SetupActions();
  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************  State sharing info  **************
    //Shared variable 0
    Attack_conf_1 = new Place("Attack_conf_1");
    addSharedPtr(Attack_conf_1, "Attack_conf_1" );
    if (Channel_1->NumStateVariables > 0) {
      Attack_conf_1->ShareWith(Channel_1->Attack_enabled);
      addSharingInfo(Channel_1->Attack_enabled, Attack_conf_1, Channel_1);
    }
    if (Adversary->NumStateVariables > 0) {
      Attack_conf_1->ShareWith(Adversary->Channel1_attacked);
      addSharingInfo(Adversary->Channel1_attacked, Attack_conf_1, Adversary);
    }

    //Shared variable 1
    Attack_conf_2 = new Place("Attack_conf_2");
    addSharedPtr(Attack_conf_2, "Attack_conf_2" );
    if (Channel_2->NumStateVariables > 0) {
      Attack_conf_2->ShareWith(Channel_2->Attack_enabled);
      addSharingInfo(Channel_2->Attack_enabled, Attack_conf_2, Channel_2);
    }
    if (Adversary->NumStateVariables > 0) {
      Attack_conf_2->ShareWith(Adversary->Channel2_attacked);
      addSharingInfo(Adversary->Channel2_attacked, Attack_conf_2, Adversary);
    }

    //Shared variable 2
    AttackedID_1 = new Place("AttackedID_1");
    addSharedPtr(AttackedID_1, "AttackedID_1" );
    if (Channel_1->NumStateVariables > 0) {
      AttackedID_1->ShareWith(Channel_1->Channel_attacked_ID);
      addSharingInfo(Channel_1->Channel_attacked_ID, AttackedID_1, Channel_1);
    }
    if (Adversary->NumStateVariables > 0) {
      AttackedID_1->ShareWith(Adversary->AttackedID_1);
      addSharingInfo(Adversary->AttackedID_1, AttackedID_1, Adversary);
    }

    //Shared variable 3
    AttackedID_2 = new Place("AttackedID_2");
    addSharedPtr(AttackedID_2, "AttackedID_2" );
    if (Channel_2->NumStateVariables > 0) {
      AttackedID_2->ShareWith(Channel_2->Channel_attacked_ID);
      addSharingInfo(Channel_2->Channel_attacked_ID, AttackedID_2, Channel_2);
    }
    if (Adversary->NumStateVariables > 0) {
      AttackedID_2->ShareWith(Adversary->AttackedID_2);
      addSharingInfo(Adversary->AttackedID_2, AttackedID_2, Adversary);
    }

    //Shared variable 4
    CCF_active = new Place("CCF_active");
    addSharedPtr(CCF_active, "CCF_active" );
    if (Channel_1->NumStateVariables > 0) {
      CCF_active->ShareWith(Channel_1->CCF_active);
      addSharingInfo(Channel_1->CCF_active, CCF_active, Channel_1);
    }
    if (Channel_2->NumStateVariables > 0) {
      CCF_active->ShareWith(Channel_2->CCF_active);
      addSharingInfo(Channel_2->CCF_active, CCF_active, Channel_2);
    }
    if (Adjudicator->NumStateVariables > 0) {
      CCF_active->ShareWith(Adjudicator->CCF_active);
      addSharingInfo(Adjudicator->CCF_active, CCF_active, Adjudicator);
    }

    //Shared variable 5
    CH1_OK = new Place("CH1_OK");
    addSharedPtr(CH1_OK, "CH1_OK" );
    if (Channel_1->NumStateVariables > 0) {
      CH1_OK->ShareWith(Channel_1->CH_OK);
      addSharingInfo(Channel_1->CH_OK, CH1_OK, Channel_1);
    }
    if (Adjudicator->NumStateVariables > 0) {
      CH1_OK->ShareWith(Adjudicator->CH1_OK);
      addSharingInfo(Adjudicator->CH1_OK, CH1_OK, Adjudicator);
    }

    //Shared variable 6
    CH1_SS_OK = new Place("CH1_SS_OK");
    addSharedPtr(CH1_SS_OK, "CH1_SS_OK" );
    if (Channel_1->NumStateVariables > 0) {
      CH1_SS_OK->ShareWith(Channel_1->ConfigurationOK);
      addSharingInfo(Channel_1->ConfigurationOK, CH1_SS_OK, Channel_1);
    }
    if (T_Conf_channel->NumStateVariables > 0) {
      CH1_SS_OK->ShareWith(T_Conf_channel->CH1_SS_OK);
      addSharingInfo(T_Conf_channel->CH1_SS_OK, CH1_SS_OK, T_Conf_channel);
    }

    //Shared variable 7
    CH1_Safe_State = new Place("CH1_Safe_State");
    addSharedPtr(CH1_Safe_State, "CH1_Safe_State" );
    if (Channel_1->NumStateVariables > 0) {
      CH1_Safe_State->ShareWith(Channel_1->Safe_state);
      addSharingInfo(Channel_1->Safe_state, CH1_Safe_State, Channel_1);
    }
    if (Adjudicator->NumStateVariables > 0) {
      CH1_Safe_State->ShareWith(Adjudicator->CH1_Safe_Failure);
      addSharingInfo(Adjudicator->CH1_Safe_Failure, CH1_Safe_State, Adjudicator);
    }

    //Shared variable 8
    CH2_OK = new Place("CH2_OK");
    addSharedPtr(CH2_OK, "CH2_OK" );
    if (Channel_2->NumStateVariables > 0) {
      CH2_OK->ShareWith(Channel_2->CH2_OK);
      addSharingInfo(Channel_2->CH2_OK, CH2_OK, Channel_2);
    }
    if (Adjudicator->NumStateVariables > 0) {
      CH2_OK->ShareWith(Adjudicator->CH2_OK);
      addSharingInfo(Adjudicator->CH2_OK, CH2_OK, Adjudicator);
    }

    //Shared variable 9
    CH2_SS_OK = new Place("CH2_SS_OK");
    addSharedPtr(CH2_SS_OK, "CH2_SS_OK" );
    if (Channel_2->NumStateVariables > 0) {
      CH2_SS_OK->ShareWith(Channel_2->ConfigurationOK);
      addSharingInfo(Channel_2->ConfigurationOK, CH2_SS_OK, Channel_2);
    }
    if (T_Conf_channel->NumStateVariables > 0) {
      CH2_SS_OK->ShareWith(T_Conf_channel->CH2_SS_OK);
      addSharingInfo(T_Conf_channel->CH2_SS_OK, CH2_SS_OK, T_Conf_channel);
    }

    //Shared variable 10
    CH2_Safe_State = new Place("CH2_Safe_State");
    addSharedPtr(CH2_Safe_State, "CH2_Safe_State" );
    if (Channel_2->NumStateVariables > 0) {
      CH2_Safe_State->ShareWith(Channel_2->CH2_Safe_state);
      addSharingInfo(Channel_2->CH2_Safe_state, CH2_Safe_State, Channel_2);
    }
    if (Adjudicator->NumStateVariables > 0) {
      CH2_Safe_State->ShareWith(Adjudicator->CH2_Safe_Failure);
      addSharingInfo(Adjudicator->CH2_Safe_Failure, CH2_Safe_State, Adjudicator);
    }

    //Shared variable 11
    C_CH_1_attacked = new Place("C_CH_1_attacked");
    addSharedPtr(C_CH_1_attacked, "C_CH_1_attacked" );
    if (Channel_1->NumStateVariables > 0) {
      C_CH_1_attacked->ShareWith(Channel_1->C_attack_enabled);
      addSharingInfo(Channel_1->C_attack_enabled, C_CH_1_attacked, Channel_1);
    }
    if (Adversary->NumStateVariables > 0) {
      C_CH_1_attacked->ShareWith(Adversary->C_CH_1_attacked);
      addSharingInfo(Adversary->C_CH_1_attacked, C_CH_1_attacked, Adversary);
    }

    //Shared variable 12
    C_CH_2_attacked = new Place("C_CH_2_attacked");
    addSharedPtr(C_CH_2_attacked, "C_CH_2_attacked" );
    if (Channel_2->NumStateVariables > 0) {
      C_CH_2_attacked->ShareWith(Channel_2->C_attack_enabled);
      addSharingInfo(Channel_2->C_attack_enabled, C_CH_2_attacked, Channel_2);
    }
    if (Adversary->NumStateVariables > 0) {
      C_CH_2_attacked->ShareWith(Adversary->C_CH_2_attacked);
      addSharingInfo(Adversary->C_CH_2_attacked, C_CH_2_attacked, Adversary);
    }

    //Shared variable 13
    System_OK = new Place("System_OK");
    addSharedPtr(System_OK, "System_OK" );
    if (Channel_1->NumStateVariables > 0) {
      System_OK->ShareWith(Channel_1->System_OK);
      addSharingInfo(Channel_1->System_OK, System_OK, Channel_1);
    }
    if (Channel_2->NumStateVariables > 0) {
      System_OK->ShareWith(Channel_2->System_OK);
      addSharingInfo(Channel_2->System_OK, System_OK, Channel_2);
    }
    if (Adjudicator->NumStateVariables > 0) {
      System_OK->ShareWith(Adjudicator->System_OK);
      addSharingInfo(Adjudicator->System_OK, System_OK, Adjudicator);
    }
    if (T_Conf_channel->NumStateVariables > 0) {
      System_OK->ShareWith(T_Conf_channel->System_OK);
      addSharingInfo(T_Conf_channel->System_OK, System_OK, T_Conf_channel);
    }

    //Shared variable 14
    System_Safe_Failure = new Place("System_Safe_Failure");
    addSharedPtr(System_Safe_Failure, "System_Safe_Failure" );
    if (Adjudicator->NumStateVariables > 0) {
      System_Safe_Failure->ShareWith(Adjudicator->System_Safe_Failure);
      addSharingInfo(Adjudicator->System_Safe_Failure, System_Safe_Failure, Adjudicator);
    }
    if (T_Conf_channel->NumStateVariables > 0) {
      System_Safe_Failure->ShareWith(T_Conf_channel->System_safe);
      addSharingInfo(T_Conf_channel->System_safe, System_Safe_Failure, T_Conf_channel);
    }

    //Shared variable 15
    System_Unsafe_State = new Place("System_Unsafe_State");
    addSharedPtr(System_Unsafe_State, "System_Unsafe_State" );
    if (Adjudicator->NumStateVariables > 0) {
      System_Unsafe_State->ShareWith(Adjudicator->System_Unsafe_State);
      addSharingInfo(Adjudicator->System_Unsafe_State, System_Unsafe_State, Adjudicator);
    }
    if (T_Conf_channel->NumStateVariables > 0) {
      System_Unsafe_State->ShareWith(T_Conf_channel->System_unsafe);
      addSharingInfo(T_Conf_channel->System_unsafe, System_Unsafe_State, T_Conf_channel);
    }

    //Shared variable 16
    Torque_Attack_in_progress = new Place("Torque_Attack_in_progress");
    addSharedPtr(Torque_Attack_in_progress, "Torque_Attack_in_progress" );
    if (Adversary->NumStateVariables > 0) {
      Torque_Attack_in_progress->ShareWith(Adversary->Torque_Attack_in_progress);
      addSharingInfo(Adversary->Torque_Attack_in_progress, Torque_Attack_in_progress, Adversary);
    }
    if (T_Conf_channel->NumStateVariables > 0) {
      Torque_Attack_in_progress->ShareWith(T_Conf_channel->Attack_in_progress);
      addSharingInfo(T_Conf_channel->Attack_in_progress, Torque_Attack_in_progress, T_Conf_channel);
    }

  }

  Setup();
}

Div_SWRJ::~Div_SWRJ() {
  if (!AllChildrenEmpty()) {
    delete Attack_conf_1;
    delete Attack_conf_2;
    delete AttackedID_1;
    delete AttackedID_2;
    delete CCF_active;
    delete CH1_OK;
    delete CH1_SS_OK;
    delete CH1_Safe_State;
    delete CH2_OK;
    delete CH2_SS_OK;
    delete CH2_Safe_State;
    delete C_CH_1_attacked;
    delete C_CH_2_attacked;
    delete System_OK;
    delete System_Safe_Failure;
    delete System_Unsafe_State;
    delete Torque_Attack_in_progress;
  }
  delete Channel_1;
  delete Channel_2;
  delete Adversary;
  delete Adjudicator;
  delete T_Conf_channel;
}
