#ifndef Div_SWRJ_H_
#define Div_SWRJ_H_
#include <math.h>
#include "Cpp/Composer/Join.h"
#include "Cpp/Composer/AllStateVariableTypes.h"
#include "Composed/Div_SW/Div_SWRJ__Channel_1.h"
#include "Composed/Div_SW/Div_SWRJ__Channel_2.h"
#include "Atomic/Adversary/AdversarySAN.h"
#include "Atomic/Adjudicator/AdjudicatorSAN.h"
#include "Atomic/T_Conf_channel/T_Conf_channelSAN.h"

//State variable headers
#include "Cpp/BaseClasses/SAN/Place.h"

class Div_SWRJ: public Join {
 public:
  Div_SWRJ__Channel_1 * Channel_1;
  Div_SWRJ__Channel_2 * Channel_2;
  AdversarySAN * Adversary;
  AdjudicatorSAN * Adjudicator;
  T_Conf_channelSAN * T_Conf_channel;
  Place * Attack_conf_1;
  Place * Attack_conf_2;
  Place * AttackedID_1;
  Place * AttackedID_2;
  Place * CCF_active;
  Place * CH1_OK;
  Place * CH1_SS_OK;
  Place * CH1_Safe_State;
  Place * CH2_OK;
  Place * CH2_SS_OK;
  Place * CH2_Safe_State;
  Place * C_CH_1_attacked;
  Place * C_CH_2_attacked;
  Place * System_OK;
  Place * System_Safe_Failure;
  Place * System_Unsafe_State;
  Place * Torque_Attack_in_progress;

  Div_SWRJ();
  ~Div_SWRJ();
};

#endif
