#include "MTT_emotorPVNodes.h"

MTT_emotorPV0Worker::MTT_emotorPV0Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&Adjudicator);
}

MTT_emotorPV0Worker::~MTT_emotorPV0Worker() {
  delete [] TheModelPtr;
}

double MTT_emotorPV0Worker::Reward_Function(void) {

if(Adjudicator->System_Safe_Failure->Mark() > 0)
  return(0.0);
else
  return(1.0);

return (0);



}

MTT_emotorPV0::MTT_emotorPV0(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheDiv_SWRJ);
  double startpts[11]={0.0, 100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 1000.0};
  double stoppts[11]={100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 1000.0, 1100.0};
  Initialize("MTT_SF",(RewardType)1,11, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("System_Safe_Failure","Adjudicator");
}

MTT_emotorPV0::~MTT_emotorPV0() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void MTT_emotorPV0::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new MTT_emotorPV0Worker;
}
MTT_emotorPV1Worker::MTT_emotorPV1Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&Adjudicator);
}

MTT_emotorPV1Worker::~MTT_emotorPV1Worker() {
  delete [] TheModelPtr;
}

double MTT_emotorPV1Worker::Reward_Function(void) {

if(Adjudicator->System_Unsafe_State->Mark() > 0)
  return(0.0);
else
  return(1.0);

return (0);



}

MTT_emotorPV1::MTT_emotorPV1(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheDiv_SWRJ);
  double startpts[11]={0.0, 100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 1000.0};
  double stoppts[11]={100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 1000.0, 1100.0};
  Initialize("MTT_USF",(RewardType)1,11, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("System_Unsafe_State","Adjudicator");
}

MTT_emotorPV1::~MTT_emotorPV1() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void MTT_emotorPV1::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new MTT_emotorPV1Worker;
}
MTT_emotorPV2Impulse0::MTT_emotorPV2Impulse0()
{
  NumberOfModelDependencies = 1;
  TheModelPtr = new BaseModelClass**[NumberOfModelDependencies];
  TheModelPtr[0] = (BaseModelClass**)(&Adjudicator);
  ImpulseWorkerListLength = 0;
}

MTT_emotorPV2Impulse0::~MTT_emotorPV2Impulse0() {
  delete [] TheModelPtr;
  if (ImpulseWorkerListLength > 0) {
    for (int ImpulseWorkerCounter = 0; ImpulseWorkerCounter < ImpulseWorkerListLength; ImpulseWorkerCounter++)
      delete ImpulseWorkerList[ImpulseWorkerCounter];
    delete[] ImpulseWorkerList;
  }
}

double MTT_emotorPV2Impulse0::Impulse_Function(double FiringTime)
{
return(1.0);

return(0);
}

ImpulseNodeClass** MTT_emotorPV2Impulse0::CreateImpulseWorkerList(int NumberOfWorkers) {
  ImpulseWorkerListLength = NumberOfWorkers;
  ImpulseWorkerList = new ImpulseNodeClass*[NumberOfWorkers];

  for (int ImpulseWorkerCounter = 0; ImpulseWorkerCounter < NumberOfWorkers; ImpulseWorkerCounter++)
  {
    ImpulseWorkerList[ImpulseWorkerCounter] = new MTT_emotorPV2Impulse0;
  }

  return ImpulseWorkerList;
}

MTT_emotorPV2::MTT_emotorPV2(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheDiv_SWRJ);
  double startpts[11]={0.0, 100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 1000.0};
  double stoppts[11]={100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 1000.0, 1100.0};
  Initialize("system_SF_count",(RewardType)1,11, startpts, stoppts, timeindex, 1,0, 0);
  AddImpulse("System_SS_Act","Adjudicator",&Impulse0);
}

MTT_emotorPV2::~MTT_emotorPV2() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void MTT_emotorPV2::CreateWorkerList(void) {
}
MTT_emotorPV3Worker::MTT_emotorPV3Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&Adjudicator);
}

MTT_emotorPV3Worker::~MTT_emotorPV3Worker() {
  delete [] TheModelPtr;
}

double MTT_emotorPV3Worker::Reward_Function(void) {

if((Adjudicator->System_Safe_Failure->Mark() > 0) || (Adjudicator->System_Unsafe_State->Mark()))
  return(1.0);
else
  return(0.0);

return (0);



}

MTT_emotorPV3::MTT_emotorPV3(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheDiv_SWRJ);
  double startpts[11]={0.0, 100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 1000.0};
  double stoppts[11]={100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 1000.0, 1100.0};
  Initialize("System_failure",(RewardType)1,11, startpts, stoppts, timeindex, 0,2, 2);
  AddVariableDependency("System_Safe_Failure","Adjudicator");
  AddVariableDependency("System_Unsafe_State","Adjudicator");
}

MTT_emotorPV3::~MTT_emotorPV3() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void MTT_emotorPV3::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new MTT_emotorPV3Worker;
}
MTT_emotorPV4Worker::MTT_emotorPV4Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&Adjudicator);
}

MTT_emotorPV4Worker::~MTT_emotorPV4Worker() {
  delete [] TheModelPtr;
}

double MTT_emotorPV4Worker::Reward_Function(void) {

if(Adjudicator->System_OK->Mark() > 0)
  return(1.0);
else
  return(0.0);

return (0);



}

MTT_emotorPV4::MTT_emotorPV4(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheDiv_SWRJ);
  double startpts[11]={0.0, 100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 1000.0};
  double stoppts[11]={100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 1000.0, 1100.0};
  Initialize("System_OK",(RewardType)1,11, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("System_OK","Adjudicator");
}

MTT_emotorPV4::~MTT_emotorPV4() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void MTT_emotorPV4::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new MTT_emotorPV4Worker;
}
MTT_emotorPV5Worker::MTT_emotorPV5Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&Adjudicator);
}

MTT_emotorPV5Worker::~MTT_emotorPV5Worker() {
  delete [] TheModelPtr;
}

double MTT_emotorPV5Worker::Reward_Function(void) {

if(Adjudicator->System_Safe_Failure->Mark() > 0)
  return(1.0);
else
  return(0.0);

return (0);



}

MTT_emotorPV5::MTT_emotorPV5(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheDiv_SWRJ);
  double startpts[11]={0.0, 100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 1000.0};
  double stoppts[11]={0.0, 100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 1000.0};
  Initialize("impulse_SF",(RewardType)0,11, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("System_Safe_Failure","Adjudicator");
}

MTT_emotorPV5::~MTT_emotorPV5() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void MTT_emotorPV5::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new MTT_emotorPV5Worker;
}
MTT_emotorPV6Worker::MTT_emotorPV6Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&Adjudicator);
}

MTT_emotorPV6Worker::~MTT_emotorPV6Worker() {
  delete [] TheModelPtr;
}

double MTT_emotorPV6Worker::Reward_Function(void) {

if(Adjudicator->System_Unsafe_State->Mark() > 0)
  return(1.0);
else
  return(0.0);

return (0);



}

MTT_emotorPV6::MTT_emotorPV6(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheDiv_SWRJ);
  double startpts[11]={0.0, 100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 1000.0};
  double stoppts[11]={0.0, 100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 1000.0};
  Initialize("impulse_USF",(RewardType)0,11, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("System_Unsafe_State","Adjudicator");
}

MTT_emotorPV6::~MTT_emotorPV6() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void MTT_emotorPV6::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new MTT_emotorPV6Worker;
}
MTT_emotorPV7Worker::MTT_emotorPV7Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&Adjudicator);
}

MTT_emotorPV7Worker::~MTT_emotorPV7Worker() {
  delete [] TheModelPtr;
}

double MTT_emotorPV7Worker::Reward_Function(void) {

if(Adjudicator->System_OK->Mark() > 0)
  return(1.0);
else
  return(0.0);

return (0);



}

MTT_emotorPV7::MTT_emotorPV7(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheDiv_SWRJ);
  double startpts[11]={0.0, 100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 1000.0};
  double stoppts[11]={0.0, 100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 1000.0};
  Initialize("impulse_OK",(RewardType)0,11, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("System_OK","Adjudicator");
}

MTT_emotorPV7::~MTT_emotorPV7() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void MTT_emotorPV7::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new MTT_emotorPV7Worker;
}
MTT_emotorPV8Worker::MTT_emotorPV8Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&T_Conf_channel);
}

MTT_emotorPV8Worker::~MTT_emotorPV8Worker() {
  delete [] TheModelPtr;
}

double MTT_emotorPV8Worker::Reward_Function(void) {

if(T_Conf_channel->FalseAlarmFlag->Mark() > 0)
  return(1.0);
else
  return(0.0);

return (0);



}

MTT_emotorPV8::MTT_emotorPV8(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheDiv_SWRJ);
  double startpts[11]={0.0, 100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 1000.0};
  double stoppts[11]={0.0, 100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 1000.0};
  Initialize("FalseAlarm",(RewardType)0,11, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("FalseAlarmFlag","T_Conf_channel");
}

MTT_emotorPV8::~MTT_emotorPV8() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void MTT_emotorPV8::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new MTT_emotorPV8Worker;
}
MTT_emotorPV9Worker::MTT_emotorPV9Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&T_Conf_channel);
}

MTT_emotorPV9Worker::~MTT_emotorPV9Worker() {
  delete [] TheModelPtr;
}

double MTT_emotorPV9Worker::Reward_Function(void) {

return(T_Conf_channel->Detected->Mark());

return (0);



}

MTT_emotorPV9::MTT_emotorPV9(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheDiv_SWRJ);
  double startpts[11]={0.0, 100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 1000.0};
  double stoppts[11]={0.0, 100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 1000.0};
  Initialize("Detected",(RewardType)0,11, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("Detected","T_Conf_channel");
}

MTT_emotorPV9::~MTT_emotorPV9() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void MTT_emotorPV9::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new MTT_emotorPV9Worker;
}
