
#include "Study/exp1/exp1SetStudy.h"

//******************************************************
//Global Variables
//******************************************************
double AttackRate;
short CC_enabler;
double CC_failure_rate;
double C_Att_Success;
double C_Rep_Success;
double C_fail_det_prob;
double Config_repair_success;
double Configuration_validation_Duration;
double ControlConfAttack;
double D_T_attack_prob;
double SS_Conf_Attack;
double SS_repair_rate;
double T_V_Offset_mean;
double T_V_Offset_stddev;
double T_V_step_interval_mean;
short T_V_steps_max;
short T_V_steps_min;
double TorqueAttack;
double USF_repair_rate;
double attack_CH1_success_pr;
double attack_CH2_success_pr;
short attack_count;
double channel_failure_rate;
double failure_coverage;
short single_SS_enabler_is_0;
double t_delta;
double t_window;
double torque_req_rate;
double v_delta;

//********************************************************
//exp1SetStudy Constructor
//********************************************************
exp1SetStudy::exp1SetStudy() {

  // define arrays of global variable names and types
  NumGVs = 29;
  NumExps = 13;

  GVNames = new char*[NumGVs];
  GVTypes = new char*[NumGVs];
  GVNames[0]=strdup("AttackRate");
  GVTypes[0]=strdup("double");
  GVNames[1]=strdup("CC_enabler");
  GVTypes[1]=strdup("short");
  GVNames[2]=strdup("CC_failure_rate");
  GVTypes[2]=strdup("double");
  GVNames[3]=strdup("C_Att_Success");
  GVTypes[3]=strdup("double");
  GVNames[4]=strdup("C_Rep_Success");
  GVTypes[4]=strdup("double");
  GVNames[5]=strdup("C_fail_det_prob");
  GVTypes[5]=strdup("double");
  GVNames[6]=strdup("Config_repair_success");
  GVTypes[6]=strdup("double");
  GVNames[7]=strdup("Configuration_validation_Duration");
  GVTypes[7]=strdup("double");
  GVNames[8]=strdup("ControlConfAttack");
  GVTypes[8]=strdup("double");
  GVNames[9]=strdup("D_T_attack_prob");
  GVTypes[9]=strdup("double");
  GVNames[10]=strdup("SS_Conf_Attack");
  GVTypes[10]=strdup("double");
  GVNames[11]=strdup("SS_repair_rate");
  GVTypes[11]=strdup("double");
  GVNames[12]=strdup("T_V_Offset_mean");
  GVTypes[12]=strdup("double");
  GVNames[13]=strdup("T_V_Offset_stddev");
  GVTypes[13]=strdup("double");
  GVNames[14]=strdup("T_V_step_interval_mean");
  GVTypes[14]=strdup("double");
  GVNames[15]=strdup("T_V_steps_max");
  GVTypes[15]=strdup("short");
  GVNames[16]=strdup("T_V_steps_min");
  GVTypes[16]=strdup("short");
  GVNames[17]=strdup("TorqueAttack");
  GVTypes[17]=strdup("double");
  GVNames[18]=strdup("USF_repair_rate");
  GVTypes[18]=strdup("double");
  GVNames[19]=strdup("attack_CH1_success_pr");
  GVTypes[19]=strdup("double");
  GVNames[20]=strdup("attack_CH2_success_pr");
  GVTypes[20]=strdup("double");
  GVNames[21]=strdup("attack_count");
  GVTypes[21]=strdup("short");
  GVNames[22]=strdup("channel_failure_rate");
  GVTypes[22]=strdup("double");
  GVNames[23]=strdup("failure_coverage");
  GVTypes[23]=strdup("double");
  GVNames[24]=strdup("single_SS_enabler_is_0");
  GVTypes[24]=strdup("short");
  GVNames[25]=strdup("t_delta");
  GVTypes[25]=strdup("double");
  GVNames[26]=strdup("t_window");
  GVTypes[26]=strdup("double");
  GVNames[27]=strdup("torque_req_rate");
  GVTypes[27]=strdup("double");
  GVNames[28]=strdup("v_delta");
  GVTypes[28]=strdup("double");

  // create the arrays to store the values of each gv
  AttackRateValues = new double[NumExps];
  CC_enablerValues = new short[NumExps];
  CC_failure_rateValues = new double[NumExps];
  C_Att_SuccessValues = new double[NumExps];
  C_Rep_SuccessValues = new double[NumExps];
  C_fail_det_probValues = new double[NumExps];
  Config_repair_successValues = new double[NumExps];
  Configuration_validation_DurationValues = new double[NumExps];
  ControlConfAttackValues = new double[NumExps];
  D_T_attack_probValues = new double[NumExps];
  SS_Conf_AttackValues = new double[NumExps];
  SS_repair_rateValues = new double[NumExps];
  T_V_Offset_meanValues = new double[NumExps];
  T_V_Offset_stddevValues = new double[NumExps];
  T_V_step_interval_meanValues = new double[NumExps];
  T_V_steps_maxValues = new short[NumExps];
  T_V_steps_minValues = new short[NumExps];
  TorqueAttackValues = new double[NumExps];
  USF_repair_rateValues = new double[NumExps];
  attack_CH1_success_prValues = new double[NumExps];
  attack_CH2_success_prValues = new double[NumExps];
  attack_countValues = new short[NumExps];
  channel_failure_rateValues = new double[NumExps];
  failure_coverageValues = new double[NumExps];
  single_SS_enabler_is_0Values = new short[NumExps];
  t_deltaValues = new double[NumExps];
  t_windowValues = new double[NumExps];
  torque_req_rateValues = new double[NumExps];
  v_deltaValues = new double[NumExps];

  // call methods to assign values to each gv
  SetValues_AttackRate();
  SetValues_CC_enabler();
  SetValues_CC_failure_rate();
  SetValues_C_Att_Success();
  SetValues_C_Rep_Success();
  SetValues_C_fail_det_prob();
  SetValues_Config_repair_success();
  SetValues_Configuration_validation_Duration();
  SetValues_ControlConfAttack();
  SetValues_D_T_attack_prob();
  SetValues_SS_Conf_Attack();
  SetValues_SS_repair_rate();
  SetValues_T_V_Offset_mean();
  SetValues_T_V_Offset_stddev();
  SetValues_T_V_step_interval_mean();
  SetValues_T_V_steps_max();
  SetValues_T_V_steps_min();
  SetValues_TorqueAttack();
  SetValues_USF_repair_rate();
  SetValues_attack_CH1_success_pr();
  SetValues_attack_CH2_success_pr();
  SetValues_attack_count();
  SetValues_channel_failure_rate();
  SetValues_failure_coverage();
  SetValues_single_SS_enabler_is_0();
  SetValues_t_delta();
  SetValues_t_window();
  SetValues_torque_req_rate();
  SetValues_v_delta();
  SetDefaultMobiusRoot(MOBIUSROOT);
}


//******************************************************
//exp1SetStudy Destructor
//******************************************************
exp1SetStudy::~exp1SetStudy() {
  delete [] AttackRateValues;
  delete [] CC_enablerValues;
  delete [] CC_failure_rateValues;
  delete [] C_Att_SuccessValues;
  delete [] C_Rep_SuccessValues;
  delete [] C_fail_det_probValues;
  delete [] Config_repair_successValues;
  delete [] Configuration_validation_DurationValues;
  delete [] ControlConfAttackValues;
  delete [] D_T_attack_probValues;
  delete [] SS_Conf_AttackValues;
  delete [] SS_repair_rateValues;
  delete [] T_V_Offset_meanValues;
  delete [] T_V_Offset_stddevValues;
  delete [] T_V_step_interval_meanValues;
  delete [] T_V_steps_maxValues;
  delete [] T_V_steps_minValues;
  delete [] TorqueAttackValues;
  delete [] USF_repair_rateValues;
  delete [] attack_CH1_success_prValues;
  delete [] attack_CH2_success_prValues;
  delete [] attack_countValues;
  delete [] channel_failure_rateValues;
  delete [] failure_coverageValues;
  delete [] single_SS_enabler_is_0Values;
  delete [] t_deltaValues;
  delete [] t_windowValues;
  delete [] torque_req_rateValues;
  delete [] v_deltaValues;
  delete ThePVModel;
}


//******************************************************
// set values for AttackRate
//******************************************************
void exp1SetStudy::SetValues_AttackRate() {
  AttackRateValues[0] = 0.01;
  AttackRateValues[1] = 0.01;
  AttackRateValues[2] = 0.001;
  AttackRateValues[3] = 0.001;
  AttackRateValues[4] = 0.001;
  AttackRateValues[5] = 0.001;
  AttackRateValues[6] = 0.001;
  AttackRateValues[7] = 0.001;
  AttackRateValues[8] = 0.001;
  AttackRateValues[9] = 0.001;
  AttackRateValues[10] = 0.01;
  AttackRateValues[11] = 0.01;
  AttackRateValues[12] = 0.01;
}


//******************************************************
// set values for CC_enabler
//******************************************************
void exp1SetStudy::SetValues_CC_enabler() {
  CC_enablerValues[0] = 1;
  CC_enablerValues[1] = 1;
  CC_enablerValues[2] = 1;
  CC_enablerValues[3] = 1;
  CC_enablerValues[4] = 1;
  CC_enablerValues[5] = 0;
  CC_enablerValues[6] = 1;
  CC_enablerValues[7] = 1;
  CC_enablerValues[8] = 1;
  CC_enablerValues[9] = 1;
  CC_enablerValues[10] = 0;
  CC_enablerValues[11] = 0;
  CC_enablerValues[12] = 0;
}


//******************************************************
// set values for CC_failure_rate
//******************************************************
void exp1SetStudy::SetValues_CC_failure_rate() {
  CC_failure_rateValues[0] = 1.0E-4;
  CC_failure_rateValues[1] = 0.01;
  CC_failure_rateValues[2] = 1.00E-04;
  CC_failure_rateValues[3] = 1.00E-04;
  CC_failure_rateValues[4] = 1.00E-04;
  CC_failure_rateValues[5] = 1.00E-04;
  CC_failure_rateValues[6] = 1.00E-04;
  CC_failure_rateValues[7] = 1.00E-04;
  CC_failure_rateValues[8] = 1.00E-04;
  CC_failure_rateValues[9] = 1.00E-04;
  CC_failure_rateValues[10] = 1.00E-04;
  CC_failure_rateValues[11] = 1.00E-04;
  CC_failure_rateValues[12] = 1.00E-04;
}


//******************************************************
// set values for C_Att_Success
//******************************************************
void exp1SetStudy::SetValues_C_Att_Success() {
  for (int n=0; n<NumExps; n++)
    C_Att_SuccessValues[n] = 0;
}


//******************************************************
// set values for C_Rep_Success
//******************************************************
void exp1SetStudy::SetValues_C_Rep_Success() {
  C_Rep_SuccessValues[0] = 0;
  C_Rep_SuccessValues[1] = 0.0;
  C_Rep_SuccessValues[2] = 0;
  C_Rep_SuccessValues[3] = 0;
  C_Rep_SuccessValues[4] = 0;
  C_Rep_SuccessValues[5] = 0;
  C_Rep_SuccessValues[6] = 0;
  C_Rep_SuccessValues[7] = 0;
  C_Rep_SuccessValues[8] = 0;
  C_Rep_SuccessValues[9] = 0;
  C_Rep_SuccessValues[10] = 0;
  C_Rep_SuccessValues[11] = 0;
  C_Rep_SuccessValues[12] = 0;
}


//******************************************************
// set values for C_fail_det_prob
//******************************************************
void exp1SetStudy::SetValues_C_fail_det_prob() {
  for (int n=0; n<NumExps; n++)
    C_fail_det_probValues[n] = 0;
}


//******************************************************
// set values for Config_repair_success
//******************************************************
void exp1SetStudy::SetValues_Config_repair_success() {
  for (int n=0; n<NumExps; n++)
    Config_repair_successValues[n] = 0.6;
}


//******************************************************
// set values for Configuration_validation_Duration
//******************************************************
void exp1SetStudy::SetValues_Configuration_validation_Duration() {
  Configuration_validation_DurationValues[0] = 0.1;
  Configuration_validation_DurationValues[1] = 0.1;
  Configuration_validation_DurationValues[2] = 0.01;
  Configuration_validation_DurationValues[3] = 0.01;
  Configuration_validation_DurationValues[4] = 0.01;
  Configuration_validation_DurationValues[5] = 0.1;
  Configuration_validation_DurationValues[6] = 0.1;
  Configuration_validation_DurationValues[7] = 0.1;
  Configuration_validation_DurationValues[8] = 0.1;
  Configuration_validation_DurationValues[9] = 0.1;
  Configuration_validation_DurationValues[10] = 0.1;
  Configuration_validation_DurationValues[11] = 0.1;
  Configuration_validation_DurationValues[12] = 0.1;
}


//******************************************************
// set values for ControlConfAttack
//******************************************************
void exp1SetStudy::SetValues_ControlConfAttack() {
  ControlConfAttackValues[0] = 0.0;
  ControlConfAttackValues[1] = 0;
  ControlConfAttackValues[2] = 0;
  ControlConfAttackValues[3] = 0;
  ControlConfAttackValues[4] = 0;
  ControlConfAttackValues[5] = 0;
  ControlConfAttackValues[6] = 0;
  ControlConfAttackValues[7] = 0;
  ControlConfAttackValues[8] = 0;
  ControlConfAttackValues[9] = 0;
  ControlConfAttackValues[10] = 0;
  ControlConfAttackValues[11] = 0;
  ControlConfAttackValues[12] = 0;
}


//******************************************************
// set values for D_T_attack_prob
//******************************************************
void exp1SetStudy::SetValues_D_T_attack_prob() {
  D_T_attack_probValues[0] = 0.0;
  D_T_attack_probValues[1] = 0.8;
  D_T_attack_probValues[2] = 0;
  D_T_attack_probValues[3] = 0;
  D_T_attack_probValues[4] = 0;
  D_T_attack_probValues[5] = 0;
  D_T_attack_probValues[6] = 0;
  D_T_attack_probValues[7] = 0;
  D_T_attack_probValues[8] = 0;
  D_T_attack_probValues[9] = 0;
  D_T_attack_probValues[10] = 1.0;
  D_T_attack_probValues[11] = 1.0;
  D_T_attack_probValues[12] = 1.0;
}


//******************************************************
// set values for SS_Conf_Attack
//******************************************************
void exp1SetStudy::SetValues_SS_Conf_Attack() {
  SS_Conf_AttackValues[0] = 1.0;
  SS_Conf_AttackValues[1] = 0.0;
  SS_Conf_AttackValues[2] = 1;
  SS_Conf_AttackValues[3] = 1;
  SS_Conf_AttackValues[4] = 1;
  SS_Conf_AttackValues[5] = 1;
  SS_Conf_AttackValues[6] = 1;
  SS_Conf_AttackValues[7] = 1;
  SS_Conf_AttackValues[8] = 1;
  SS_Conf_AttackValues[9] = 1;
  SS_Conf_AttackValues[10] = 0.0;
  SS_Conf_AttackValues[11] = 0.0;
  SS_Conf_AttackValues[12] = 0.0;
}


//******************************************************
// set values for SS_repair_rate
//******************************************************
void exp1SetStudy::SetValues_SS_repair_rate() {
  SS_repair_rateValues[0] = 36.0;
  SS_repair_rateValues[1] = 36;
  SS_repair_rateValues[2] = 36;
  SS_repair_rateValues[3] = 36;
  SS_repair_rateValues[4] = 36;
  SS_repair_rateValues[5] = 36;
  SS_repair_rateValues[6] = 36;
  SS_repair_rateValues[7] = 360;
  SS_repair_rateValues[8] = 3.6;
  SS_repair_rateValues[9] = 36;
  SS_repair_rateValues[10] = 36;
  SS_repair_rateValues[11] = 36;
  SS_repair_rateValues[12] = 36;
}


//******************************************************
// set values for T_V_Offset_mean
//******************************************************
void exp1SetStudy::SetValues_T_V_Offset_mean() {
  for (int n=0; n<NumExps; n++)
    T_V_Offset_meanValues[n] = 0.5;
}


//******************************************************
// set values for T_V_Offset_stddev
//******************************************************
void exp1SetStudy::SetValues_T_V_Offset_stddev() {
  for (int n=0; n<NumExps; n++)
    T_V_Offset_stddevValues[n] = 0.1;
}


//******************************************************
// set values for T_V_step_interval_mean
//******************************************************
void exp1SetStudy::SetValues_T_V_step_interval_mean() {
  T_V_step_interval_meanValues[0] = 0.05;
  T_V_step_interval_meanValues[1] = 0.05;
  T_V_step_interval_meanValues[2] = 0.01;
  T_V_step_interval_meanValues[3] = 0.01;
  T_V_step_interval_meanValues[4] = 0.01;
  T_V_step_interval_meanValues[5] = 0.05;
  T_V_step_interval_meanValues[6] = 0.05;
  T_V_step_interval_meanValues[7] = 0.05;
  T_V_step_interval_meanValues[8] = 0.05;
  T_V_step_interval_meanValues[9] = 0.05;
  T_V_step_interval_meanValues[10] = 0.05;
  T_V_step_interval_meanValues[11] = 0.05;
  T_V_step_interval_meanValues[12] = 0.05;
}


//******************************************************
// set values for T_V_steps_max
//******************************************************
void exp1SetStudy::SetValues_T_V_steps_max() {
  T_V_steps_maxValues[0] = 7;
  T_V_steps_maxValues[1] = 7;
  T_V_steps_maxValues[2] = 3;
  T_V_steps_maxValues[3] = 3;
  T_V_steps_maxValues[4] = 3;
  T_V_steps_maxValues[5] = 7;
  T_V_steps_maxValues[6] = 7;
  T_V_steps_maxValues[7] = 7;
  T_V_steps_maxValues[8] = 7;
  T_V_steps_maxValues[9] = 7;
  T_V_steps_maxValues[10] = 2;
  T_V_steps_maxValues[11] = 7;
  T_V_steps_maxValues[12] = 10;
}


//******************************************************
// set values for T_V_steps_min
//******************************************************
void exp1SetStudy::SetValues_T_V_steps_min() {
  T_V_steps_minValues[0] = 3;
  T_V_steps_minValues[1] = 3;
  T_V_steps_minValues[2] = 1;
  T_V_steps_minValues[3] = 1;
  T_V_steps_minValues[4] = 1;
  T_V_steps_minValues[5] = 3;
  T_V_steps_minValues[6] = 3;
  T_V_steps_minValues[7] = 3;
  T_V_steps_minValues[8] = 3;
  T_V_steps_minValues[9] = 3;
  T_V_steps_minValues[10] = 1;
  T_V_steps_minValues[11] = 3;
  T_V_steps_minValues[12] = 5;
}


//******************************************************
// set values for TorqueAttack
//******************************************************
void exp1SetStudy::SetValues_TorqueAttack() {
  TorqueAttackValues[0] = 0.5;
  TorqueAttackValues[1] = 0.0;
  TorqueAttackValues[2] = 0.5;
  TorqueAttackValues[3] = 0.5;
  TorqueAttackValues[4] = 0.5;
  TorqueAttackValues[5] = 0.5;
  TorqueAttackValues[6] = 0.5;
  TorqueAttackValues[7] = 0.5;
  TorqueAttackValues[8] = 0.5;
  TorqueAttackValues[9] = 0.5;
  TorqueAttackValues[10] = 1.0;
  TorqueAttackValues[11] = 1.0;
  TorqueAttackValues[12] = 1.0;
}


//******************************************************
// set values for USF_repair_rate
//******************************************************
void exp1SetStudy::SetValues_USF_repair_rate() {
  USF_repair_rateValues[0] = 360.0;
  USF_repair_rateValues[1] = 360.0;
  USF_repair_rateValues[2] = 360;
  USF_repair_rateValues[3] = 360;
  USF_repair_rateValues[4] = 360;
  USF_repair_rateValues[5] = 360;
  USF_repair_rateValues[6] = 36;
  USF_repair_rateValues[7] = 36;
  USF_repair_rateValues[8] = 36;
  USF_repair_rateValues[9] = 360;
  USF_repair_rateValues[10] = 360.0;
  USF_repair_rateValues[11] = 360.0;
  USF_repair_rateValues[12] = 360.0;
}


//******************************************************
// set values for attack_CH1_success_pr
//******************************************************
void exp1SetStudy::SetValues_attack_CH1_success_pr() {
  for (int n=0; n<NumExps; n++)
    attack_CH1_success_prValues[n] = 0.2;
}


//******************************************************
// set values for attack_CH2_success_pr
//******************************************************
void exp1SetStudy::SetValues_attack_CH2_success_pr() {
  for (int n=0; n<NumExps; n++)
    attack_CH2_success_prValues[n] = 0.1;
}


//******************************************************
// set values for attack_count
//******************************************************
void exp1SetStudy::SetValues_attack_count() {
  attack_countValues[0] = 10;
  attack_countValues[1] = 0;
  attack_countValues[2] = 0;
  attack_countValues[3] = 0;
  attack_countValues[4] = 0;
  attack_countValues[5] = 0;
  attack_countValues[6] = 10;
  attack_countValues[7] = 10;
  attack_countValues[8] = 10;
  attack_countValues[9] = 10;
  attack_countValues[10] = 10;
  attack_countValues[11] = 10;
  attack_countValues[12] = 10;
}


//******************************************************
// set values for channel_failure_rate
//******************************************************
void exp1SetStudy::SetValues_channel_failure_rate() {
  for (int n=0; n<NumExps; n++)
    channel_failure_rateValues[n] = 0.001;
}


//******************************************************
// set values for failure_coverage
//******************************************************
void exp1SetStudy::SetValues_failure_coverage() {
  failure_coverageValues[0] = 0.8;
  failure_coverageValues[1] = 0.8;
  failure_coverageValues[2] = 0.3;
  failure_coverageValues[3] = 0.5;
  failure_coverageValues[4] = 0.8;
  failure_coverageValues[5] = 0.8;
  failure_coverageValues[6] = 0.8;
  failure_coverageValues[7] = 0.8;
  failure_coverageValues[8] = 0.8;
  failure_coverageValues[9] = 0.8;
  failure_coverageValues[10] = 0.0;
  failure_coverageValues[11] = 0.0;
  failure_coverageValues[12] = 0.0;
}


//******************************************************
// set values for single_SS_enabler_is_0
//******************************************************
void exp1SetStudy::SetValues_single_SS_enabler_is_0() {
  single_SS_enabler_is_0Values[0] = 0;
  single_SS_enabler_is_0Values[1] = 1;
  single_SS_enabler_is_0Values[2] = 0;
  single_SS_enabler_is_0Values[3] = 0;
  single_SS_enabler_is_0Values[4] = 0;
  single_SS_enabler_is_0Values[5] = 0;
  single_SS_enabler_is_0Values[6] = 1;
  single_SS_enabler_is_0Values[7] = 1;
  single_SS_enabler_is_0Values[8] = 1;
  single_SS_enabler_is_0Values[9] = 1;
  single_SS_enabler_is_0Values[10] = 1;
  single_SS_enabler_is_0Values[11] = 1;
  single_SS_enabler_is_0Values[12] = 1;
}


//******************************************************
// set values for t_delta
//******************************************************
void exp1SetStudy::SetValues_t_delta() {
  t_deltaValues[0] = 10.0;
  t_deltaValues[1] = 10.0;
  t_deltaValues[2] = 30;
  t_deltaValues[3] = 30;
  t_deltaValues[4] = 30;
  t_deltaValues[5] = 10;
  t_deltaValues[6] = 10;
  t_deltaValues[7] = 10;
  t_deltaValues[8] = 10;
  t_deltaValues[9] = 10;
  t_deltaValues[10] = 0.001;
  t_deltaValues[11] = 0.001;
  t_deltaValues[12] = 0.001;
}


//******************************************************
// set values for t_window
//******************************************************
void exp1SetStudy::SetValues_t_window() {
  t_windowValues[0] = 25.0;
  t_windowValues[1] = 1.0E-4;
  t_windowValues[2] = 25;
  t_windowValues[3] = 25;
  t_windowValues[4] = 25;
  t_windowValues[5] = 25;
  t_windowValues[6] = 25;
  t_windowValues[7] = 25;
  t_windowValues[8] = 25;
  t_windowValues[9] = 25;
  t_windowValues[10] = 5.0E-4;
  t_windowValues[11] = 5.0E-4;
  t_windowValues[12] = 5.0E-4;
}


//******************************************************
// set values for torque_req_rate
//******************************************************
void exp1SetStudy::SetValues_torque_req_rate() {
  torque_req_rateValues[0] = 0.02;
  torque_req_rateValues[1] = 0.02;
  torque_req_rateValues[2] = 0.02;
  torque_req_rateValues[3] = 0.02;
  torque_req_rateValues[4] = 0.02;
  torque_req_rateValues[5] = 0.02;
  torque_req_rateValues[6] = 0.02;
  torque_req_rateValues[7] = 0.02;
  torque_req_rateValues[8] = 0.02;
  torque_req_rateValues[9] = 0.02;
  torque_req_rateValues[10] = 100.0;
  torque_req_rateValues[11] = 100.0;
  torque_req_rateValues[12] = 100.0;
}


//******************************************************
// set values for v_delta
//******************************************************
void exp1SetStudy::SetValues_v_delta() {
  for (int n=0; n<NumExps; n++)
    v_deltaValues[n] = 0.2;
}



//******************************************************
//print values of gv (for debugging)
//******************************************************
void exp1SetStudy::PrintGlobalValues(int expNum) {
  if (NumGVs == 0) {
    cout<<"There are no global variables."<<endl;
    return;
  }

  SetGVs(expNum);

  cout<<"The Global Variable values for experiment "<<
    GetExpName(expNum)<<" are:"<<endl;
  cout << "AttackRate\tdouble\t" << AttackRate << endl;
  cout << "CC_enabler\tshort\t" << CC_enabler << endl;
  cout << "CC_failure_rate\tdouble\t" << CC_failure_rate << endl;
  cout << "C_Att_Success\tdouble\t" << C_Att_Success << endl;
  cout << "C_Rep_Success\tdouble\t" << C_Rep_Success << endl;
  cout << "C_fail_det_prob\tdouble\t" << C_fail_det_prob << endl;
  cout << "Config_repair_success\tdouble\t" << Config_repair_success << endl;
  cout << "Configuration_validation_Duration\tdouble\t" << Configuration_validation_Duration << endl;
  cout << "ControlConfAttack\tdouble\t" << ControlConfAttack << endl;
  cout << "D_T_attack_prob\tdouble\t" << D_T_attack_prob << endl;
  cout << "SS_Conf_Attack\tdouble\t" << SS_Conf_Attack << endl;
  cout << "SS_repair_rate\tdouble\t" << SS_repair_rate << endl;
  cout << "T_V_Offset_mean\tdouble\t" << T_V_Offset_mean << endl;
  cout << "T_V_Offset_stddev\tdouble\t" << T_V_Offset_stddev << endl;
  cout << "T_V_step_interval_mean\tdouble\t" << T_V_step_interval_mean << endl;
  cout << "T_V_steps_max\tshort\t" << T_V_steps_max << endl;
  cout << "T_V_steps_min\tshort\t" << T_V_steps_min << endl;
  cout << "TorqueAttack\tdouble\t" << TorqueAttack << endl;
  cout << "USF_repair_rate\tdouble\t" << USF_repair_rate << endl;
  cout << "attack_CH1_success_pr\tdouble\t" << attack_CH1_success_pr << endl;
  cout << "attack_CH2_success_pr\tdouble\t" << attack_CH2_success_pr << endl;
  cout << "attack_count\tshort\t" << attack_count << endl;
  cout << "channel_failure_rate\tdouble\t" << channel_failure_rate << endl;
  cout << "failure_coverage\tdouble\t" << failure_coverage << endl;
  cout << "single_SS_enabler_is_0\tshort\t" << single_SS_enabler_is_0 << endl;
  cout << "t_delta\tdouble\t" << t_delta << endl;
  cout << "t_window\tdouble\t" << t_window << endl;
  cout << "torque_req_rate\tdouble\t" << torque_req_rate << endl;
  cout << "v_delta\tdouble\t" << v_delta << endl;
}


//******************************************************
//retrieve the value of a global variable
//******************************************************
void *exp1SetStudy::GetGVValue(char *TheGVName) {
  if (strcmp("AttackRate", TheGVName) == 0)
    return &AttackRate;
  else if (strcmp("CC_enabler", TheGVName) == 0)
    return &CC_enabler;
  else if (strcmp("CC_failure_rate", TheGVName) == 0)
    return &CC_failure_rate;
  else if (strcmp("C_Att_Success", TheGVName) == 0)
    return &C_Att_Success;
  else if (strcmp("C_Rep_Success", TheGVName) == 0)
    return &C_Rep_Success;
  else if (strcmp("C_fail_det_prob", TheGVName) == 0)
    return &C_fail_det_prob;
  else if (strcmp("Config_repair_success", TheGVName) == 0)
    return &Config_repair_success;
  else if (strcmp("Configuration_validation_Duration", TheGVName) == 0)
    return &Configuration_validation_Duration;
  else if (strcmp("ControlConfAttack", TheGVName) == 0)
    return &ControlConfAttack;
  else if (strcmp("D_T_attack_prob", TheGVName) == 0)
    return &D_T_attack_prob;
  else if (strcmp("SS_Conf_Attack", TheGVName) == 0)
    return &SS_Conf_Attack;
  else if (strcmp("SS_repair_rate", TheGVName) == 0)
    return &SS_repair_rate;
  else if (strcmp("T_V_Offset_mean", TheGVName) == 0)
    return &T_V_Offset_mean;
  else if (strcmp("T_V_Offset_stddev", TheGVName) == 0)
    return &T_V_Offset_stddev;
  else if (strcmp("T_V_step_interval_mean", TheGVName) == 0)
    return &T_V_step_interval_mean;
  else if (strcmp("T_V_steps_max", TheGVName) == 0)
    return &T_V_steps_max;
  else if (strcmp("T_V_steps_min", TheGVName) == 0)
    return &T_V_steps_min;
  else if (strcmp("TorqueAttack", TheGVName) == 0)
    return &TorqueAttack;
  else if (strcmp("USF_repair_rate", TheGVName) == 0)
    return &USF_repair_rate;
  else if (strcmp("attack_CH1_success_pr", TheGVName) == 0)
    return &attack_CH1_success_pr;
  else if (strcmp("attack_CH2_success_pr", TheGVName) == 0)
    return &attack_CH2_success_pr;
  else if (strcmp("attack_count", TheGVName) == 0)
    return &attack_count;
  else if (strcmp("channel_failure_rate", TheGVName) == 0)
    return &channel_failure_rate;
  else if (strcmp("failure_coverage", TheGVName) == 0)
    return &failure_coverage;
  else if (strcmp("single_SS_enabler_is_0", TheGVName) == 0)
    return &single_SS_enabler_is_0;
  else if (strcmp("t_delta", TheGVName) == 0)
    return &t_delta;
  else if (strcmp("t_window", TheGVName) == 0)
    return &t_window;
  else if (strcmp("torque_req_rate", TheGVName) == 0)
    return &torque_req_rate;
  else if (strcmp("v_delta", TheGVName) == 0)
    return &v_delta;
  else 
    cerr<<"!! exp1SetStudy::GetGVValue: Global Variable "<<TheGVName<<" does not exist."<<endl;
  return NULL;
}


//******************************************************
//override the value of a global variable
//******************************************************
void exp1SetStudy::OverrideGVValue(char *TheGVName,void *TheGVValue) {
  if (strcmp("AttackRate", TheGVName) == 0)
    AttackRate = *(double *)TheGVValue;
  else if (strcmp("CC_enabler", TheGVName) == 0)
    CC_enabler = *(short *)TheGVValue;
  else if (strcmp("CC_failure_rate", TheGVName) == 0)
    CC_failure_rate = *(double *)TheGVValue;
  else if (strcmp("C_Att_Success", TheGVName) == 0)
    C_Att_Success = *(double *)TheGVValue;
  else if (strcmp("C_Rep_Success", TheGVName) == 0)
    C_Rep_Success = *(double *)TheGVValue;
  else if (strcmp("C_fail_det_prob", TheGVName) == 0)
    C_fail_det_prob = *(double *)TheGVValue;
  else if (strcmp("Config_repair_success", TheGVName) == 0)
    Config_repair_success = *(double *)TheGVValue;
  else if (strcmp("Configuration_validation_Duration", TheGVName) == 0)
    Configuration_validation_Duration = *(double *)TheGVValue;
  else if (strcmp("ControlConfAttack", TheGVName) == 0)
    ControlConfAttack = *(double *)TheGVValue;
  else if (strcmp("D_T_attack_prob", TheGVName) == 0)
    D_T_attack_prob = *(double *)TheGVValue;
  else if (strcmp("SS_Conf_Attack", TheGVName) == 0)
    SS_Conf_Attack = *(double *)TheGVValue;
  else if (strcmp("SS_repair_rate", TheGVName) == 0)
    SS_repair_rate = *(double *)TheGVValue;
  else if (strcmp("T_V_Offset_mean", TheGVName) == 0)
    T_V_Offset_mean = *(double *)TheGVValue;
  else if (strcmp("T_V_Offset_stddev", TheGVName) == 0)
    T_V_Offset_stddev = *(double *)TheGVValue;
  else if (strcmp("T_V_step_interval_mean", TheGVName) == 0)
    T_V_step_interval_mean = *(double *)TheGVValue;
  else if (strcmp("T_V_steps_max", TheGVName) == 0)
    T_V_steps_max = *(short *)TheGVValue;
  else if (strcmp("T_V_steps_min", TheGVName) == 0)
    T_V_steps_min = *(short *)TheGVValue;
  else if (strcmp("TorqueAttack", TheGVName) == 0)
    TorqueAttack = *(double *)TheGVValue;
  else if (strcmp("USF_repair_rate", TheGVName) == 0)
    USF_repair_rate = *(double *)TheGVValue;
  else if (strcmp("attack_CH1_success_pr", TheGVName) == 0)
    attack_CH1_success_pr = *(double *)TheGVValue;
  else if (strcmp("attack_CH2_success_pr", TheGVName) == 0)
    attack_CH2_success_pr = *(double *)TheGVValue;
  else if (strcmp("attack_count", TheGVName) == 0)
    attack_count = *(short *)TheGVValue;
  else if (strcmp("channel_failure_rate", TheGVName) == 0)
    channel_failure_rate = *(double *)TheGVValue;
  else if (strcmp("failure_coverage", TheGVName) == 0)
    failure_coverage = *(double *)TheGVValue;
  else if (strcmp("single_SS_enabler_is_0", TheGVName) == 0)
    single_SS_enabler_is_0 = *(short *)TheGVValue;
  else if (strcmp("t_delta", TheGVName) == 0)
    t_delta = *(double *)TheGVValue;
  else if (strcmp("t_window", TheGVName) == 0)
    t_window = *(double *)TheGVValue;
  else if (strcmp("torque_req_rate", TheGVName) == 0)
    torque_req_rate = *(double *)TheGVValue;
  else if (strcmp("v_delta", TheGVName) == 0)
    v_delta = *(double *)TheGVValue;
  else 
    cerr<<"!! exp1SetStudy::OverrideGVValue: Global Variable "<<TheGVName<<" does not exist."<<endl;
}


//******************************************************
//set the value of all global variables to the given exp
//******************************************************
void exp1SetStudy::SetGVs(int expNum) {
  AttackRate = AttackRateValues[expNum];
  CC_enabler = CC_enablerValues[expNum];
  CC_failure_rate = CC_failure_rateValues[expNum];
  C_Att_Success = C_Att_SuccessValues[expNum];
  C_Rep_Success = C_Rep_SuccessValues[expNum];
  C_fail_det_prob = C_fail_det_probValues[expNum];
  Config_repair_success = Config_repair_successValues[expNum];
  Configuration_validation_Duration = Configuration_validation_DurationValues[expNum];
  ControlConfAttack = ControlConfAttackValues[expNum];
  D_T_attack_prob = D_T_attack_probValues[expNum];
  SS_Conf_Attack = SS_Conf_AttackValues[expNum];
  SS_repair_rate = SS_repair_rateValues[expNum];
  T_V_Offset_mean = T_V_Offset_meanValues[expNum];
  T_V_Offset_stddev = T_V_Offset_stddevValues[expNum];
  T_V_step_interval_mean = T_V_step_interval_meanValues[expNum];
  T_V_steps_max = T_V_steps_maxValues[expNum];
  T_V_steps_min = T_V_steps_minValues[expNum];
  TorqueAttack = TorqueAttackValues[expNum];
  USF_repair_rate = USF_repair_rateValues[expNum];
  attack_CH1_success_pr = attack_CH1_success_prValues[expNum];
  attack_CH2_success_pr = attack_CH2_success_prValues[expNum];
  attack_count = attack_countValues[expNum];
  channel_failure_rate = channel_failure_rateValues[expNum];
  failure_coverage = failure_coverageValues[expNum];
  single_SS_enabler_is_0 = single_SS_enabler_is_0Values[expNum];
  t_delta = t_deltaValues[expNum];
  t_window = t_windowValues[expNum];
  torque_req_rate = torque_req_rateValues[expNum];
  v_delta = v_deltaValues[expNum];
}


//******************************************************
//static class method called by solvers to create study 
//(and thus create all of the model)
//******************************************************
BaseStudyClass* GlobalStudyPtr = NULL;
BaseStudyClass * GenerateStudy() {
  if (GlobalStudyPtr == NULL)
    GlobalStudyPtr = new exp1SetStudy();
  return GlobalStudyPtr;
}

void DestructStudy() {
  delete GlobalStudyPtr;
  GlobalStudyPtr = NULL;
}
//******************************************************
//get and create the PVModel
//******************************************************
PVModel* exp1SetStudy::GetPVModel(bool expandTimeArrays) {
  if (ThePVModel!=NULL)
    delete ThePVModel;
  // create the PV model
  ThePVModel=new MTT_emotorPVModel(expandTimeArrays);
  return ThePVModel;
}


